/*
 * Copyright (C) 2003-2004 by Jocelyn Mayer <l_indien@magic.fr>
 * distributed under the GNU Lesser General Public License
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 * 
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 */

#ifndef __LIB_REMAP_H__
#define __LIB_REMAP_H__

typedef struct file_t {
    char *name;
    int type;
    unsigned long *blocs;
} file_t;

void bdrm_register_msg_stream (FILE * stream);
void bdrm_restore_msg_stream (void);
void bdrm_register_error_stream (FILE * stream);
void bdrm_restore_error_stream (void);

int bdrm_add_file (file_t **const file_list, unsigned int *const nb_files,
                   const char *name, const int type, const int verbose);
void bdrm_free_list (file_t **file_list, unsigned int nb_files);

int bdrm_do_unmap (const unsigned char *chrdev,
                   const int dev, const int simulate);
int bdrm_do_map (const unsigned char *chrdev, file_t **const file_list,
                 unsigned int *const nb_files, const char *const mp,
                 const unsigned int blocsize, const int verbose,
                 const int simulate, int *minor);
int bdrm_get_map (const unsigned char *chrdev, const char *const mp,
                  int *minor);

#endif /* __LIB_REMAP_H__ */
